unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus;

type
  TStudent = record
   jmeno, prijmeni: string[50];
   vek:18..110;
   pohlavi:(muz,zena);
   predmety:array [1..10] of string[10];
  end;

  TStudentList = array of TStudent;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Kartot1: TMenuItem;
    Student1: TMenuItem;
    Nova1: TMenuItem;
    Nacist1: TMenuItem;
    Uloyit1: TMenuItem;
    ExportdoCSV1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Pridat1: TMenuItem;
    Odebrat1: TMenuItem;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ExportCSV: TSaveDialog;
    procedure Nova1Click(Sender: TObject);
    procedure Nacist1Click(Sender: TObject);
    procedure Uloyit1Click(Sender: TObject);
    procedure ExportdoCSV1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Pridat1Click(Sender: TObject);
    procedure Odebrat1Click(Sender: TObject);
  private
    studenti:TStudentList;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit3;

{$R *.dfm}

procedure TForm1.Nova1Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
end;

procedure TForm1.Nacist1Click(Sender: TObject);
var studenti:file of TStudent;
    line:string;
    i:integer;
begin
 if Opendialog1.Execute then
 begin
  AssignFile(studenti,Opendialog1.FileName);
  reset(studenti);
  while not eof(studenti) do
  begin
    setLength(self.studenti, length(self.Studenti)+1);
    read(studenti,self.studenti[length(self.studenti)-1]);
    with self.studenti[length(self.studenti)-1] do
    begin
     line := line + jmeno +', ' + prijmeni +', ' + inttostr(vek);
     case pohlavi of
      muz: line:= line + ', muz';
      zena:line:= line + ', zena';
     end;
     for i:=low(predmety) to high(predmety) do
      if predmety[i] <> '' then
       line := line +', ' + predmety[i];
    end;
  end;
  ListBox1.Items.Add(line);
  CloseFile(studenti);
 end;
end;

procedure TForm1.Uloyit1Click(Sender: TObject);
var data:file of TStudent;
    i:integer;
begin
 if SaveDialog1.Execute then
 begin
  AssignFile(data,SaveDialog1.FileName);
  rewrite(data);
  for i:= low(studenti) to high(studenti) do
  begin
    write(data,studenti[i]);
  end;
  CloseFile(data);
 end;
end;

procedure TForm1.ExportdoCSV1Click(Sender: TObject);
begin
 if ExportCSV.Execute then
  ListBox1.Items.SaveToFile(ExportCSV.FileName);
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Pridat1Click(Sender: TObject);
var pomPredmety:TSeznamPredmetu;
    line:string;
    i,j:integer;
begin
 if form3.showmodal = mrOk then
 begin
  setLength(studenti,length(Studenti) + 1);
  with studenti[length(studenti)-1] do
  begin
   jmeno:=form3.jmeno.text;
   line := jmeno;
   prijmeni := form3.prijmeni.text;
   line := line +', ' + prijmeni;
   vek := form3.getVek;
   line := line +', ' + inttostr(vek);
   case form3.Pohlavi.ItemIndex of
    0:begin
       pohlavi:=muz;
       line:= line +', muz';
      end;
    1:begin
       pohlavi := zena;
       line := line + ', zena';
      end;
   end;
   pomPredmety := form3.predmety;
   j:=low(pomPredmety);
   for i:=low(pomPredmety) to high(pomPredmety) do
    if pomPredmety[i] <>'' then
    begin
     predmety[j] := pomPredmety[i];
     line := line +', ' + pomPredmety[i];
     inc(j);
    end;
  end;
  ListBox1.Items.add(line);
 end;
end;

procedure TForm1.Odebrat1Click(Sender: TObject);
 procedure odeberStudenta(idx:integer);
 var i,j:integer;
     pomStudenti:TStudentList;
 begin
  setLength(pomStudenti,length(studenti)-1);
  for i:=0 to length(studenti) -1 do
  begin
   if i<> idx then
   begin
    pomStudenti[j] := studenti[i];
    inc(j);
   end;
  end;
  studenti := pomStudenti;
 end;
var studIdx:integer;
begin
 if ListBox1.ItemIndex > -1 then
 begin
  studIdx := ListBox1.ItemIndex;
  ListBox1.Items.Delete(studIdx);
  odeberStudenta(studIdx);
 end;
end;

end.


